<template>
    <div>
        <loading :active.sync="loading" is-full-page></loading>
        <md-dialog id="modal-login" :md-active.sync="classicModal" class="md-round classic-modal">
            <div class="md-layout md-alignment-top-right">
                <md-button class="md-icon-button" @click="registerModalHide">
                    <md-icon>clear</md-icon>
                </md-button>
            </div>

            <md-dialog-content>
                <div class="text-align-center">
                    <p class="modal-title">¡BIENVENIDO!</p>
                    <p class="modal-title"><strong>REGISTRARME</strong></p>
                </div>

                <form novalidate>
                    <md-field :class="getValidationClass('email')">
                        <!-- <md-icon>email</md-icon> -->
                        <label for="email">Email</label>
                        <md-input v-model="register.email" id="email" type="email"></md-input>
                        <span class="md-error">Email requerido o invalido</span>
                    </md-field>
                    <md-field class="mt-2" :class="getValidationClass('password')">
                        <!-- <md-icon>lock_outline</md-icon> -->
                        <label for="password">Contraseña</label>
                        <md-input v-model="register.password" type="password"></md-input>
                        <span class="md-error" style="margin-bottom: 2px;"
                            >Contraseña requerida. La contraseña debe contener al menos 8 caracteres. Al menos un número, una mayúscula, una minúscula
                            y uno de los siguientes signos (! @ # $ % ^ &amp; *)
                        </span>
                    </md-field>
                    <md-field class="mt-2" :class="getValidationClass('password_confirmation')">
                        <!-- <md-icon>lock_outline</md-icon> -->
                        <label for="password_confirmation">Confirmar contraseña</label>
                        <md-input v-model="register.password_confirmation" type="password"></md-input>
                        <span class="md-error">Confirme su contraseña</span>
                    </md-field>
                    <div class="md-layout md-alignment-center-center">
                        <div class="md-layout-item md-size-100">
                            <md-radio v-model="termAndConditions" class="text-align-left" />
                            <span
                                >Acepto los <router-link target="_blank" :to="{ name: 'termsandconditions' }">términos y condiciones</router-link>
                            </span>
                        </div>
                    </div>
                    <md-button class="md-primary md-block md-radius" :disabled="loading" @click="validateUser">REGISTRAR</md-button>
                </form>
            </md-dialog-content>
        </md-dialog>
    </div>
</template>

<script>
// import { LoginCard } from "../components";
import axios from 'axios';
import { Modal } from '../../components';
import { validationMixin } from 'vuelidate';
import { required, email, minLength, maxLength, helpers } from 'vuelidate/lib/validators';
const alpha = helpers.regex('alpha', /^(?=.*\d)(?=.*[\u0021-\u002b\u003c-\u0040])(?=.*[A-Z])(?=.*[a-z])\S{8,16}$/);
export default {
    name: 'register-section',
    bodyClass: 'register-modal',
    props: {
        showModal: {
            type: Boolean,
            default: false
        }
    },
    mixins: [validationMixin],
    components: {
        Modal
        // LoginCard
    },
    data() {
        return {
            loading: false,
            termAndConditions: false,
            registerAlert: false,
            register: {
                email: null,
                password: null,
                password_confirmation: null
            },
            endPoint: '/api/register',
            loading: false
        };
    },
    validations: {
        register: {
            email: {
                required,
                email
            },
            password: {
                required,
                alpha,
                minLength: minLength(8)
            },
            password_confirmation: {
                required,
                minLength: minLength(8)
            }
        }
    },
    computed: {
        classicModal() {
            return this.showModal;
        }
    },
    methods: {
        registerModalHide() {
            this.$emit('registerModalHide', event);
        },
        getValidationClass(fieldName) {
            const field = this.$v.register[fieldName];

            if (field) {
                return {
                    'md-invalid': field.$invalid && field.$dirty
                };
            }
        },
        clearForm() {
            this.$v.$reset();
            this.register.email = null;
            this.register.password = null;
            this.register.password_confirmation = null;
            this.termAndConditions = false;
        },
        validateUser() {
            this.$v.$touch();

            if (!this.$v.$invalid) {
                if (!this.termAndConditions) {
                    this.$root.WarnMgs('Acepte términos y condiciones');
                    return;
                }
                this.registerUser();
            }
        },
        registerUser() {
            this.loading = true;
            this.register.username = this.register.email;

            axios
                .post(this.endPoint, this.register)
                .then((response) => {
                    if (response && response.data) {
                        if (response.data.status == 'success') {
                            this.clearForm();
                            this.$root.SuccessMgs('Registro exitoso');
                            this.registerModalHide();
                        }
                    }
                })
                .catch((error) => {
                    if (error.response?.data?.errors) {
                        console.log(error.response?.data?.errors);

                        if (error.response?.data?.errors?.password) {
                            this.$root.WarnMgs(error.response?.data?.errors?.password[0]);
                        } else if (error.response?.data?.errors?.email) {
                            this.$root.WarnMgs(error.response?.data?.errors?.email[0]);
                        }
                    }
                })
                .finally((res) => {
                    this.loading = false;
                });
        }
    }
};
</script>

<style lang="scss" scoped>

@media screen and (min-width: 767px) {
    #modal-login {
        width: 600px;
    }

    .md-dialog {
        top: 35% !important;
    }
}

.modal-title {
    margin: 5px 0px;
    font-size: x-large;
}
</style>
